Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_continue.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_continue.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_continue.php	(revision )
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $optional_attributes = array('levels');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -34,25 +35,26 @@
     /**
      * Compiles code for the {continue} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         static $_is_loopy = array('for' => true, 'foreach' => true, 'while' => true, 'section' => true);
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
 
         if ($_attr['nocache'] === true) {
-            $compiler->trigger_template_error('nocache option not allowed', $compiler->lex->taglineno);
+            $compiler->trigger_template_error('nocache option not allowed', null, true);
         }
 
         if (isset($_attr['levels'])) {
             if (!is_numeric($_attr['levels'])) {
-                $compiler->trigger_template_error('level attribute must be a numeric constant', $compiler->lex->taglineno);
+                $compiler->trigger_template_error('level attribute must be a numeric constant', null, true);
             }
             $_levels = $_attr['levels'];
         } else {
@@ -67,7 +69,7 @@
             $stack_count --;
         }
         if ($level_count != 0) {
-            $compiler->trigger_template_error("cannot continue {$_levels} level(s)", $compiler->lex->taglineno);
+            $compiler->trigger_template_error("cannot continue {$_levels} level(s)", null, true);
         }
 
         return "<?php continue {$_levels};?>";
Index: src/includes/classes/Smarty/sysplugins/smarty_template_config.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_template_config.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_template_config.php	(revision )
@@ -0,0 +1,97 @@
+<?php
+/**
+ * Smarty Config Source Plugin
+ *
+ * @package    Smarty
+ * @subpackage TemplateResources
+ * @author     Uwe Tews
+ */
+
+/**
+ * Smarty Connfig Resource Data Object
+ * Meta Data Container for Template Files
+ *
+ * @package    Smarty
+ * @subpackage TemplateResources
+ * @author     Uwe Tews
+ *
+ */
+class Smarty_Template_Config extends Smarty_Template_Source
+{
+    /**
+     * array of section names, single section or null
+     *
+     * @var null|string|array
+     */
+    public $config_sections = null;
+
+    /**
+     * scope into which the config variables shall be loaded
+     *
+     * @var string
+     */
+    public $scope = 'local';
+
+    /**
+     * Flag that source is a config file
+     *
+     * @var bool
+     */
+    public $isConfig = true;
+
+    /**
+     * create Source Object container
+     *
+     * @param Smarty_Resource $handler  Resource Handler this source object communicates with
+     * @param Smarty          $smarty   Smarty instance this source object belongs to
+     * @param string          $resource full template_resource
+     * @param string          $type     type of resource
+     * @param string          $name     resource name
+     */
+    public function __construct(Smarty_Resource $handler, Smarty $smarty, $resource, $type, $name)
+    {
+        // must clone handler as we change class names
+        $this->handler = clone $handler; // Note: prone to circular references
+        $this->handler->compiler_class = 'Smarty_Internal_Config_File_Compiler';
+        $this->handler->template_lexer_class = 'Smarty_Internal_Configfilelexer';
+        $this->handler->template_parser_class = 'Smarty_Internal_Configfileparser';
+        $this->resource = $resource;
+        $this->type = $type;
+        $this->name = $name;
+        $this->smarty = $smarty;
+    }
+
+    /**
+     * initialize Source Object for given resource
+     * Either [$_template] or [$smarty, $template_resource] must be specified
+     *
+     * @param  Smarty_Internal_Template $_template         template object
+     * @param  Smarty                   $smarty            smarty object
+     * @param  string                   $template_resource resource identifier
+     *
+     * @return Smarty_Template_Config Source Object
+     * @throws SmartyException
+     */
+    public static function load(Smarty_Internal_Template $_template = null, Smarty $smarty = null, $template_resource = null)
+    {
+        static $_incompatible_resources = array('extends' => true, 'php' => true);
+        $template_resource = $_template->template_resource;
+        if (empty($template_resource)) {
+            throw new SmartyException('Missing config name');
+        }
+        // parse resource_name, load resource handler
+        list($name, $type) = Smarty_Resource::parseResourceName($template_resource, $_template->smarty->default_config_type);
+        // make sure configs are not loaded via anything smarty can't handle
+        if (isset($_incompatible_resources[$type])) {
+            throw new SmartyException ("Unable to use resource '{$type}' for config");
+        }
+        $resource = Smarty_Resource::load($_template->smarty, $type);
+        $source = new Smarty_Template_Config($resource, $_template->smarty, $template_resource, $type, $name);
+        $resource->populate($source, $_template);
+        if (!$source->exists && isset($_template->smarty->default_config_handler_func)) {
+            Smarty_Internal_Method_RegisterDefaultTemplateHandler::_getDefaultTemplate($source);
+        }
+        $source->unique_resource = $resource->buildUniqueResourceName($_template->smarty, $name, true);
+        return $source;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_getdebugtemplate.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_getdebugtemplate.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_getdebugtemplate.php	(revision )
@@ -0,0 +1,35 @@
+<?php
+
+/**
+ * Smarty Method GetDebugTemplate
+ *
+ * Smarty::getDebugTemplate() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_GetDebugTemplate
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * return name of debugging template
+     *
+     * @api Smarty::getDebugTemplate()
+
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     *
+     * @return string
+     */
+    public function getDebugTemplate(Smarty_Internal_TemplateBase $obj)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        return $smarty->debug_tpl;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/modifier.replace.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifier.replace.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifier.replace.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/plugins/modifiercompiler.from_charset.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.from_charset.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.from_charset.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree.php	(revision )
@@ -14,15 +14,10 @@
  * @subpackage Compiler
  * @ignore
  */
-abstract class _smarty_parsetree
+abstract class Smarty_Internal_ParseTree
 {
+
     /**
-     * Parser object
-     *
-     * @var object
-     */
-    public $parser;
-    /**
      * Buffer content
      *
      * @var mixed
@@ -39,323 +34,21 @@
     /**
      * Return buffer
      *
+     * @param \Smarty_Internal_Templateparser $parser
+     *
      * @return string buffer content
      */
-    abstract public function to_smarty_php();
-}
+    abstract public function to_smarty_php(Smarty_Internal_Templateparser $parser);
 
-/**
+    /**
- * A complete smarty tag.
- *
- * @package    Smarty
- * @subpackage Compiler
- * @ignore
+     * Template data object destructor
- */
+     */
-class _smarty_tag extends _smarty_parsetree
+    public function __destruct()
-{
+    {
-    /**
-     * Saved block nesting level
-     *
-     * @var int
-     */
-    public $saved_block_nesting;
-
-    /**
-     * Create parse tree buffer for Smarty tag
-     *
-     * @param object $parser parser object
-     * @param string $data   content
-     */
-    public function __construct($parser, $data)
-    {
-        $this->parser = $parser;
-        $this->data = $data;
-        $this->saved_block_nesting = $parser->block_nesting_level;
+        $this->data = null;
+        $this->subtrees = null;
     }
 
-    /**
-     * Return buffer content
-     *
-     * @return string content
-     */
-    public function to_smarty_php()
-    {
-        return $this->data;
-    }
+}
 
-    /**
-     * Return complied code that loads the evaluated output of buffer content into a temporary variable
-     *
-     * @return string template code
-     */
-    public function assign_to_var()
-    {
-        $var = sprintf('$_tmp%d', ++Smarty_Internal_Templateparser::$prefix_number);
-        $this->parser->compiler->prefix_code[] = sprintf("<?php ob_start();\n%s\n%s=ob_get_clean();?>", preg_replace(array('/^\s*<\?php\s+/','/\s*\?>\s*$/'), '', $this->data), $var);
 
-        return $var;
-    }
-}
-
-/**
- * Code fragment inside a tag.
- *
- * @package    Smarty
- * @subpackage Compiler
- * @ignore
- */
-class _smarty_code extends _smarty_parsetree
-{
-    /**
-     * Create parse tree buffer for code fragment
-     *
-     * @param object $parser parser object
-     * @param string $data   content
-     */
-    public function __construct($parser, $data)
-    {
-        $this->parser = $parser;
-        $this->data = $data;
-    }
-
-    /**
-     * Return buffer content in parentheses
-     *
-     * @return string content
-     */
-    public function to_smarty_php()
-    {
-        return sprintf("(%s)", $this->data);
-    }
-}
-
-/**
- * Double quoted string inside a tag.
- *
- * @package    Smarty
- * @subpackage Compiler
- * @ignore
- */
-class _smarty_doublequoted extends _smarty_parsetree
-{
-    /**
-     * Create parse tree buffer for double quoted string subtrees
-     *
-     * @param object            $parser  parser object
-     * @param _smarty_parsetree $subtree parsetree buffer
-     */
-    public function __construct($parser, _smarty_parsetree $subtree)
-    {
-        $this->parser = $parser;
-        $this->subtrees[] = $subtree;
-        if ($subtree instanceof _smarty_tag) {
-            $this->parser->block_nesting_level = count($this->parser->compiler->_tag_stack);
-        }
-    }
-
-    /**
-     * Append buffer to subtree
-     *
-     * @param _smarty_parsetree $subtree parsetree buffer
-     */
-    public function append_subtree(_smarty_parsetree $subtree)
-    {
-        $last_subtree = count($this->subtrees) - 1;
-        if ($last_subtree >= 0 && $this->subtrees[$last_subtree] instanceof _smarty_tag && $this->subtrees[$last_subtree]->saved_block_nesting < $this->parser->block_nesting_level) {
-            if ($subtree instanceof _smarty_code) {
-                $this->subtrees[$last_subtree]->data .= '<?php echo ' . $subtree->data . ';?>';
-            } elseif ($subtree instanceof _smarty_dq_content) {
-                $this->subtrees[$last_subtree]->data .= '<?php echo "' . $subtree->data . '";?>';
-            } else {
-                $this->subtrees[$last_subtree]->data .= $subtree->data;
-            }
-        } else {
-            $this->subtrees[] = $subtree;
-        }
-        if ($subtree instanceof _smarty_tag) {
-            $this->parser->block_nesting_level = count($this->parser->compiler->_tag_stack);
-        }
-    }
-
-    /**
-     * Merge subtree buffer content together
-     *
-     * @return string compiled template code
-     */
-    public function to_smarty_php()
-    {
-        $code = '';
-        foreach ($this->subtrees as $subtree) {
-            if ($code !== "") {
-                $code .= ".";
-            }
-            if ($subtree instanceof _smarty_tag) {
-                $more_php = $subtree->assign_to_var();
-            } else {
-                $more_php = $subtree->to_smarty_php();
-            }
-
-            $code .= $more_php;
-
-            if (!$subtree instanceof _smarty_dq_content) {
-                $this->parser->compiler->has_variable_string = true;
-            }
-        }
-
-        return $code;
-    }
-}
-
-/**
- * Raw chars as part of a double quoted string.
- *
- * @package    Smarty
- * @subpackage Compiler
- * @ignore
- */
-class _smarty_dq_content extends _smarty_parsetree
-{
-    /**
-     * Create parse tree buffer with string content
-     *
-     * @param object $parser parser object
-     * @param string $data   string section
-     */
-    public function __construct($parser, $data)
-    {
-        $this->parser = $parser;
-        $this->data = $data;
-    }
-
-    /**
-     * Return content as double quoted string
-     *
-     * @return string doubled quoted string
-     */
-    public function to_smarty_php()
-    {
-        return '"' . $this->data . '"';
-    }
-}
-
-/**
- * Template element
- *
- * @package    Smarty
- * @subpackage Compiler
- * @ignore
- */
-class _smarty_template_buffer extends _smarty_parsetree
-{
-    /**
-     * Array of template elements
-     *
-     * @var array
-     */
-    public $subtrees = Array();
-
-    /**
-     * Create root of parse tree for template elements
-     *
-     * @param object $parser parse object
-     */
-    public function __construct($parser)
-    {
-        $this->parser = $parser;
-    }
-
-    /**
-     * Append buffer to subtree
-     *
-     * @param _smarty_parsetree $subtree
-     */
-    public function append_subtree(_smarty_parsetree $subtree)
-    {
-        if ($subtree->data !== '') {
-            $this->subtrees[] = $subtree;
-        }
-    }
-
-    /**
-     * Sanitize and merge subtree buffers together
-     *
-     * @return string template code content
-     */
-    public function to_smarty_php()
-    {
-        $code = '';
-        for ($key = 0, $cnt = count($this->subtrees); $key < $cnt; $key ++) {
-            if ($this->subtrees[$key] instanceof _smarty_text) {
-                $subtree = $this->subtrees[$key]->to_smarty_php();
-                while ($key + 1 < $cnt && ($this->subtrees[$key+1] instanceof _smarty_text || $this->subtrees[$key +1]->data == '')) {
-                    $key++;
-                    if ($this->subtrees[$key]->data == '') {
-                        continue;
-                    }
-                    $subtree .= $this->subtrees[$key]->to_smarty_php();
-                }
-                if ($subtree == '') {
-                    continue;
-                }
-                $code .= preg_replace('/(<%|%>|<\?php|<\?|\?>|<\/?script)/', "<?php echo '\$1'; ?>\n", $subtree);
-                continue;
-            }
-            if ($this->subtrees[$key] instanceof _smarty_tag) {
-                $subtree = $this->subtrees[$key]->to_smarty_php();
-                while ($key + 1 < $cnt && ($this->subtrees[$key+1] instanceof _smarty_tag || $this->subtrees[$key +1]->data == '')) {
-                    $key++;
-                    if ($this->subtrees[$key]->data == '') {
-                        continue;
-                    }
-                    $newCode = $this->subtrees[$key]->to_smarty_php();
-                    if ((preg_match('/^\s*<\?php\s+/', $newCode) &&  preg_match('/\s*\?>\s*$/', $subtree))) {
-                        $subtree = preg_replace('/\s*\?>\s*$/', "\n", $subtree);
-                        $subtree .= preg_replace('/^\s*<\?php\s+/', '', $newCode);
-                    } else {
-                        $subtree .= $newCode;
-                    }
-                }
-                if ($subtree == '') {
-                    continue;
-                }
-                $code .= $subtree;
-                continue;
-            }
-            $code .= $this->subtrees[$key]->to_smarty_php();
-        }
-        return $code;
-    }
-
-}
-
-/**
- * template text
- *
- * @package    Smarty
- * @subpackage Compiler
- * @ignore
- */
-class _smarty_text extends _smarty_parsetree
-{
-    /**
-     * Create template text buffer
-     *
-     * @param object $parser parser object
-     * @param string $data   text
-     */
-    public function __construct($parser, $data)
-    {
-        $this->parser = $parser;
-        $this->data = $data;
-    }
-
-    /**
-     * Return buffer content
-     *
-     * @return strint text
-     */
-    public function to_smarty_php()
-    {
-        return $this->data;
-    }
-}
Index: src/includes/classes/Smarty/sysplugins/smarty_data.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_data.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_data.php	(revision )
@@ -0,0 +1,68 @@
+<?php
+/**
+ * Smarty Plugin Data
+ * This file contains the data object
+ *
+ * @package    Smarty
+ * @subpackage Template
+ * @author     Uwe Tews
+ */
+
+/**
+ * class for the Smarty data object
+ * The Smarty data object will hold Smarty variables in the current scope
+ *
+ * @package    Smarty
+ * @subpackage Template
+ */
+class Smarty_Data extends Smarty_Internal_Data
+{
+    /**
+     * Counter
+     *
+     * @var int
+     */
+    static $count = 0;
+
+    /**
+     * Data block name
+     *
+     * @var string
+     */
+    public $dataObjectName = '';
+
+    /**
+     * Smarty object
+     *
+     * @var Smarty
+     */
+    public $smarty = null;
+
+    /**
+     * create Smarty data object
+     *
+     * @param Smarty|array                    $_parent parent template
+     * @param Smarty|Smarty_Internal_Template $smarty  global smarty instance
+     * @param string                          $name    optional data block name
+     *
+     * @throws SmartyException
+     */
+    public function __construct($_parent = null, $smarty = null, $name = null)
+    {
+        parent::__construct();
+        self::$count ++;
+        $this->dataObjectName = 'Data_object ' . (isset($name) ? "'{$name}'" : self::$count);
+        $this->smarty = $smarty;
+        if (is_object($_parent)) {
+            // when object set up back pointer
+            $this->parent = $_parent;
+        } elseif (is_array($_parent)) {
+            // set up variable values
+            foreach ($_parent as $_key => $_val) {
+                $this->tpl_vars[$_key] = new Smarty_Variable($_val);
+            }
+        } elseif ($_parent != null) {
+            throw new SmartyException("Wrong type for template variables");
+        }
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_template.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_template.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_template.php	(revision )
@@ -13,120 +13,90 @@
  *
  * @package    Smarty
  * @subpackage Template
- * @property Smarty_Template_Source   $source
+ *
+ * @property Smarty_Template_Source|Smarty_Template_Config $source
- * @property Smarty_Template_Compiled $compiled
+ * @property Smarty_Template_Compiled                      $compiled
- * @property Smarty_Template_Cached   $cached
+ * @property Smarty_Template_Cached                        $cached
+ * @method bool mustCompile()
  */
 class Smarty_Internal_Template extends Smarty_Internal_TemplateBase
 {
     /**
-     * cache_id
+     * This object type (Smarty = 1, template = 2, data = 4)
      *
-     * @var string
+     * @var int
      */
-    public $cache_id = null;
+    public $_objType = 2;
+
     /**
-     * $compile_id
-     * @var string
-     */
-    public $compile_id = null;
-    /**
-     * caching enabled
+     * Global smarty instance
      *
-     * @var boolean
+     * @var Smarty
      */
-    public $caching = null;
+    public $smarty = null;
+
     /**
-     * cache lifetime in seconds
+     * Source instance
      *
-     * @var integer
+     * @var Smarty_Template_Source|Smarty_Template_Config
      */
-    public $cache_lifetime = null;
+    public $source = null;
+
     /**
      * Template resource
      *
      * @var string
      */
     public $template_resource = null;
+
     /**
      * flag if compiled template is invalid and must be (re)compiled
      *
      * @var bool
      */
     public $mustCompile = null;
+
     /**
-     * flag if template does contain nocache code sections
+     * Template Id
      *
-     * @var bool
+     * @var null|string
      */
-    public $has_nocache_code = false;
+    public $templateId = null;
+
     /**
-     * special compiled and cached template properties
+     * Known template functions
      *
      * @var array
      */
-    public $properties = array('file_dependency' => array(),
-                               'nocache_hash'    => '',
-                               'function'        => array());
+    public $tpl_function = array();
+
     /**
-     * required plugins
+     * Scope in which template is rendered
      *
-     * @var array
+     * @var int
      */
-    public $required_plugins = array('compiled' => array(), 'nocache' => array());
-    /**
-     * Global smarty instance
-     *
-     * @var Smarty
-     */
-    public $smarty = null;
-    /**
-     * blocks for template inheritance
-     *
-     * @var array
-     */
-    public $block_data = array();
-    /**
-     * variable filters
-     *
-     * @var array
-     */
-    public $variable_filters = array();
-    /**
-     * optional log of tag/attributes
-     *
-     * @var array
-     */
-    public $used_tags = array();
-    /**
-     * internal flag to allow relative path in child template blocks
-     *
-     * @var bool
-     */
-    public $allow_relative_path = false;
-    /**
-     * internal capture runtime stack
-     *
-     * @var array
-     */
-    public $_capture_stack = array(0 => array());
+    public $scope = 0;
 
     /**
      * Create template data object
      * Some of the global Smarty settings copied to template scope
-     * It load the required template resources and cacher plugins
+     * It load the required template resources and caching plugins
      *
-     * @param string                   $template_resource template resource string
+     * @param string                                                  $template_resource template resource string
-     * @param Smarty                   $smarty            Smarty instance
+     * @param Smarty                                                  $smarty            Smarty instance
-     * @param Smarty_Internal_Template $_parent           back pointer to parent object with variables or null
+     * @param \Smarty_Internal_Template|\Smarty|\Smarty_Internal_Data $_parent           back pointer to parent object
+     *                                                                                   with variables or null
-     * @param mixed                    $_cache_id         cache   id or null
+     * @param mixed                                                   $_cache_id         cache   id or null
-     * @param mixed                    $_compile_id       compile id or null
+     * @param mixed                                                   $_compile_id       compile id or null
-     * @param bool                     $_caching          use caching?
+     * @param bool                                                    $_caching          use caching?
-     * @param int                      $_cache_lifetime   cache life-time in seconds
+     * @param int                                                     $_cache_lifetime   cache life-time in seconds
+     *
+     * @throws \SmartyException
      */
-    public function __construct($template_resource, $smarty, $_parent = null, $_cache_id = null, $_compile_id = null, $_caching = null, $_cache_lifetime = null)
+    public function __construct($template_resource, Smarty $smarty, Smarty_Internal_Data $_parent = null,
+                                $_cache_id = null, $_compile_id = null, $_caching = null, $_cache_lifetime = null)
     {
-        $this->smarty = & $smarty;
+        $this->smarty = &$smarty;
         // Smarty parameter
         $this->cache_id = $_cache_id === null ? $this->smarty->cache_id : $_cache_id;
         $this->compile_id = $_compile_id === null ? $this->smarty->compile_id : $_compile_id;
